#include "windows.h"


void Log(LPTSTR msg)
{
	HANDLE hLog;
	DWORD dw;
	hLog = CreateFile(TEXT("msnap.log"), GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hLog == INVALID_HANDLE_VALUE) {
		hLog = CreateFile(TEXT("msnap.log"), GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
#ifdef UNICODE		
		WriteFile(hLog, "\xFF\xFE", 2, &dw, NULL);
#endif
	} else {
		SetFilePointer(hLog, 0, NULL, FILE_END);
	}
	TCHAR buf[1024];
	SYSTEMTIME stUTC, stLocal;
	GetSystemTime(&stUTC);
	SystemTimeToTzSpecificLocalTime(NULL, &stUTC, &stLocal);
	int cch = wsprintf(buf, TEXT("%4d-%02d-%02d  %02d:%02d:%02d.%03d  %s\r\n"),
		stLocal.wYear, stLocal.wMonth, stLocal.wDay,
		stLocal.wHour, stLocal.wMinute, stLocal.wSecond, stLocal.wMilliseconds,
		msg);
	WriteFile(hLog, buf, sizeof(TCHAR)*cch, &dw, NULL);
	CloseHandle(hLog);
}


void ErrorExit(LPTSTR lpszFunction)
{
	TCHAR szBuf[80];
	LPVOID lpMsgBuf;
	DWORD dw = GetLastError();

    FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER |
		FORMAT_MESSAGE_FROM_SYSTEM,
		NULL,
		dw,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR) &lpMsgBuf,
		0, NULL );

	wsprintf(szBuf,
		TEXT("%s failed with error %d: %s"),
		lpszFunction, dw, lpMsgBuf);

	Log(szBuf);
	MessageBox(NULL, szBuf, NULL, MB_OK | MB_ICONERROR | MB_TASKMODAL);

	LocalFree(lpMsgBuf);
	ExitProcess(dw);
}


char *memmem(void *buf, int buf_len, void *byte_sequence, int byte_sequence_len)
{
	char *bf = (char *)buf;
	char *bs = (char *)byte_sequence;
	char *p  = bf;

	while (byte_sequence_len <= (buf_len-(p-bf))) {
		if ((p = (char*) memchr(p, *bs, buf_len-(p-bf))) != NULL) {
			if ((memcmp(p, byte_sequence, byte_sequence_len)) == 0) {
				return p;
			} else {
				p++;
			}
		} else {
			break;
		}
	}
	return NULL;
}


int bufappend(char **d, int ld, char *s, int ls)
{
	char *tmp;
	int l;

	tmp = NULL;

	if (*d) {
		l = ld + ls;
		tmp = (char*)LocalAlloc(LPTR, l);
		if (!tmp)
			ErrorExit(TEXT("LocalAlloc"));
		memcpy(tmp, *d, ld);
		memcpy(tmp+ld, s, ls);
		LocalFree(*d);
		*d = tmp;
	} else {
		l = ls;
		*d = (char*)LocalAlloc(LPTR, l);
		if (!*d)
			ErrorExit(TEXT("LocalAlloc"));
		memcpy(*d, s, l);
	}

	return l;
}
